using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using System.ComponentModel;
using System.Data;

namespace DataTable_Filtering
{
    public class FilteringViewModel : INotifyPropertyChanged
    {

        Context context;
        public FilteringViewModel(Context context)
        {
            this.context = context;
        }
        private DataTable dataTable;

        public DataTable DataTable
        {
            get { return dataTable; }
            set { this.dataTable = value; }
        }


        private string filtertext = "";
        private string selectedcolumn = "All Columns";
        private string selectedcondition = "Equals";

        internal delegate void FilterChanged();

        internal FilterChanged filtertextchanged;


        public string FilterText
        {
            get { return filtertext; }
            set
            {
                filtertext = value;
                OnFilterTextChanged();
                RaisePropertyChanged("FilterText");
            }

        }

        public string SelectedCondition
        {
            get { return selectedcondition; }
            set { selectedcondition = value; }
        }

        public string SelectedColumn
        {
            get { return selectedcolumn; }
            set { selectedcolumn = value; }
        }

        private void OnFilterTextChanged()
        {
            filtertextchanged();
        }

        public void SetRowstoGenerate(int count)
        {
            dataTable = new DataTable();
            dataTable.Columns.Add("Name");
            dataTable.Columns.Add("ID");

            for (int i = 1; i < count; i++)
            {
                dataTable.Rows.Add("Name" + i.ToString(), 10000 + i);
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}